<!--
Copyright 2020 The Chromium Authors. All rights reserved.
Use of this source code is governed by a BSD-style license that can be
found in the LICENSE file.
-->

<!--
This file is used to generate a comprehensive list of Printing histograms
along with a detailed description for each histogram.

For best practices on writing histogram descriptions, see
https://chromium.googlesource.com/chromium/src.git/+/HEAD/tools/metrics/histograms/README.md

Please send CLs to chromium-metrics-reviews@google.com rather than to specific
individuals. These CLs will be automatically reassigned to a reviewer within
about 5 minutes. This approach helps the metrics team to load-balance incoming
reviews. Googlers can read more about this at go/gwsq-gerrit.
-->

<histogram-configuration>

<histograms>

<histogram name="Printing.ConversionSize.Emf" units="KB"
    expires_after="2021-04-30">
  <owner>thestig@chromium.org</owner>
  <owner>awscreen@chromium.org</owner>
  <summary>
    On Windows, the average size of a printed page after converting to EMF.
  </summary>
</histogram>

<histogram name="Printing.ConversionSize.EmfWithGdiText" units="KB"
    expires_after="2021-04-30">
  <owner>thestig@chromium.org</owner>
  <owner>awscreen@chromium.org</owner>
  <summary>
    On Windows, the average size of a printed page after converting to EMF with
    the GDI Text experiment turned on.
  </summary>
</histogram>

<histogram name="Printing.ConversionSize.EmfWithReducedRasterization"
    units="KB" expires_after="2021-04-30">
  <owner>thestig@chromium.org</owner>
  <owner>awscreen@chromium.org</owner>
  <summary>
    On Windows, the average size of a printed page after converting to EMF with
    the reduced rasterization feature turned on.
  </summary>
</histogram>

<histogram name="Printing.ConversionSize.EmfWithReducedRasterizationAndGdiText"
    units="KB" expires_after="2021-04-30">
  <owner>thestig@chromium.org</owner>
  <owner>awscreen@chromium.org</owner>
  <summary>
    On Windows, the average size of a printed page after converting to EMF with
    the reduced rasterization feature turned on and the GDI Text experiment
    turned on.
  </summary>
</histogram>

<histogram name="Printing.ConversionSize.PostScript2" units="KB"
    expires_after="2021-04-30">
  <owner>thestig@chromium.org</owner>
  <owner>awscreen@chromium.org</owner>
  <summary>
    On Windows, the average size of a printed page after converting to level 2
    PostScript.
  </summary>
</histogram>

<histogram name="Printing.ConversionSize.PostScript3" units="KB"
    expires_after="2021-04-30">
  <owner>thestig@chromium.org</owner>
  <owner>awscreen@chromium.org</owner>
  <summary>
    On Windows, the average size of a printed page after converting to level 3
    PostScript.
  </summary>
</histogram>

<histogram name="Printing.ConversionSize.Pwg" units="KB"
    expires_after="2021-04-30">
  <owner>thestig@chromium.org</owner>
  <owner>awscreen@chromium.org</owner>
  <summary>
    On desktop, the average size of a printed page after converting to PWG
    Raster format.
  </summary>
</histogram>

<histogram name="Printing.CUPS.AddressResolutionResult" enum="BooleanSuccess"
    expires_after="M85">
  <owner>skau@chromium.org</owner>
  <summary>
    Records whether resolution of a .local address via mDNS was successful. The
    metric is recorded during attempted setup of a printer discovered via mDNS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.HighestIppVersion" enum="IppVersion"
    expires_after="2021-05-30">
  <owner>skau@chromium.org</owner>
  <owner>pawliczek@chromium.org</owner>
  <summary>
    Records the highest IPP version reported by a printer when we query the
    printer for attributes. Useful to understand the population of printers
    currently used. Recorded during printer setup for IPP printers. Recorded
    only on ChromeOS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.IppAttributes" enum="IppAttribute"
    expires_after="M82">
  <owner>vkuzkokov@chromium.org</owner>
  <owner>skau@chromium.org</owner>
  <summary>
    Records when advanced attribute is set for a print job. Recorded when print
    job is being formed for sending.
  </summary>
</histogram>

<histogram name="Printing.CUPS.IppAttributesCount" units="count"
    expires_after="M82">
  <owner>vkuzkokov@chromium.org</owner>
  <owner>skau@chromium.org</owner>
  <summary>
    Records the number of advanced capabilities made available by a single
    printer. Recorded when attributes are pulled from the printer.
  </summary>
</histogram>

<histogram name="Printing.CUPS.IppAttributesSuccess" enum="BooleanSuccess"
    expires_after="M85">
  <owner>skau@chromium.org</owner>
  <summary>
    Record if the request for IPP attributes was successful during printer
    setup. This only occurs for setup attempts of IPP and IPPS printers.
    Starting with M79, this is only recorded if the printer was reachable.
  </summary>
</histogram>

<histogram name="Printing.CUPS.IppAttributesUsed" units="count"
    expires_after="M82">
  <owner>vkuzkokov@chromium.org</owner>
  <owner>skau@chromium.org</owner>
  <summary>
    Records the number of advanced attributes used by a single print job.
    Recorded when print job is being formed for sending.
  </summary>
</histogram>

<histogram name="Printing.CUPS.IppDeviceReachable" enum="BooleanSuccess"
    expires_after="M85">
  <owner>skau@chromium.org</owner>
  <summary>
    Record if the request for IPP attributes was successful in reaching the
    printer. Recorded during the attempt to setup IPP/IPPS printers.
  </summary>
</histogram>

<histogram name="Printing.CUPS.JobDuration.JobCancelled" units="ms"
    expires_after="2021-06-01">
  <owner>jschettler@chromium.org</owner>
  <owner>project-bolton@google.com</owner>
  <summary>
    Records the print job duration of a cancelled print job. Includes time spent
    in a suspended or error state. Only recorded on Chrome OS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.JobDuration.JobDone" units="ms"
    expires_after="2021-06-01">
  <owner>jschettler@chromium.org</owner>
  <owner>project-bolton@google.com</owner>
  <summary>
    Records the print job duration of a done/completed print job. Includes time
    spent in a suspended or error state. Only recorded on Chrome OS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.JobResult" enum="PrintJobResult"
    expires_after="M85">
  <owner>skau@chromium.org</owner>
  <summary>
    The final status of every print job that was succesfully queued. Only used
    on Chrome OS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.MigratedMakeAndModel" enum="BooleanMigrated"
    expires_after="2021-06-06">
  <owner>luum@chromium.org</owner>
  <owner>cros-printing-dev@chromium.org</owner>
  <summary>
    Records when a synced printer's outdated separate make and model strings
    have been migrated to the new merged form. Recorded during initial sync
    across PrintersSyncBridge.
  </summary>
</histogram>

<histogram name="Printing.CUPS.NearbyNetworkPrintersCount" units="printers"
    expires_after="2021-05-16">
  <owner>skau@chromium.org</owner>
  <owner>project-bolton@google.com</owner>
  <summary>
    The number of detected network printers that have not been saved. Recorded
    when the user navigates to the OS Settings Printing page to set up printers.
    Only recorded on Chrome OS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.PrintDocumentSize" units="KB"
    expires_after="2021-06-01">
  <owner>jschettler@chromium.org</owner>
  <owner>project-bolton@google.com</owner>
  <summary>
    Records the total size of the printed document (PDF) sent to CUPS. Only
    recorded on Chrome OS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.PrinterAdded" enum="PrinterProtocol"
    expires_after="2021-10-01">
  <owner>skau@chromium.org</owner>
  <owner>src/chromeos/printing/OWNERS</owner>
  <summary>
    The protocol for a printer that was added. Used to track printer churn by
    protocol. Only on Chrome OS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.PrinterRemoved" enum="PrinterProtocol"
    expires_after="2021-10-01">
  <owner>skau@chromium.org</owner>
  <owner>src/chromeos/printing/OWNERS</owner>
  <summary>
    The protocol for a printer that was removed. Used to track printer churn by
    protocol. Only on Chrome OS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.PrintersDiscovered" units="printers"
    expires_after="2021-10-01">
  <owner>skau@chromium.org</owner>
  <owner>src/chromeos/printing/OWNERS</owner>
  <summary>
    The number of printers shown in the discovered printers dialog during
    printer set up. Only recorded on Chrome OS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.PrinterSetupResult" enum="PrinterSetupResult"
    expires_after="2021-10-01">
  <owner>skau@chromium.org</owner>
  <owner>src/chromeos/printing/OWNERS</owner>
  <summary>
    The success or error code for the setup of a CUPS printer. Recorded when
    setup is attempted through the settings dialogs. Only recorded on Chrome OS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.PrinterStatusQueryResult"
    enum="PrinterStatusQueryResult" expires_after="2021-08-10">
  <owner>gavinwill@chromium.org</owner>
  <owner>cros-peripherals@google.com</owner>
  <summary>
    Records the success outcome of a printer status query to a local printer.
  </summary>
</histogram>

<histogram name="Printing.CUPS.PrinterStatusReasons"
    enum="PrinterStatusReasons" expires_after="2021-08-10">
  <owner>gavinwill@chromium.org</owner>
  <owner>cros-peripherals@google.com</owner>
  <summary>
    Records the status reasons returned by a local printer from a printer status
    query. Each returned printer status request can contain multiple status
    reasons so summing these buckets will overcount the total # of status
    queries.
  </summary>
</histogram>

<histogram name="Printing.CUPS.PrintJobsQueued" units="count"
    expires_after="M85">
  <obsolete>
    New data not needed 2020-10
  </obsolete>
  <owner>skau@chromium.org</owner>
  <summary>
    The size of the print queue when a print job is initially queued. When the
    first job is started, a zero is recorded. Only used on Chrome OS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.PrintManagementAppEntryPoint"
    enum="PrintManagementAppEntryPoint" expires_after="2021-06-22">
  <owner>jimmyxgong@chromium.org</owner>
  <owner>cros-peripherals@google.com</owner>
  <summary>
    Records the entry point of where the Print Management App was launched from
    in Chrome OS. Used to track the relative entry points of the app.
  </summary>
</histogram>

<histogram name="Printing.CUPS.ProtocolUsed" enum="PrinterProtocol"
    expires_after="M85">
  <owner>skau@chromium.org</owner>
  <summary>
    Records the protocol for a selected printer in Chrome OS. Used to track
    usage of the various printer protocols. Since a selection occurs when print
    preview is opened, this will count at least one every time that happens if a
    CUPS printer was selected.
  </summary>
</histogram>

<histogram name="Printing.CUPS.TotalNetworkPrintersCount" units="printers"
    expires_after="2021-05-16">
  <owner>skau@chromium.org</owner>
  <owner>project-bolton@google.com</owner>
  <summary>
    The total number of detected network printers. Recorded when the user
    navigates to the OS Settings Printing page to set up printers. Only recorded
    on Chrome OS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.UnknownPpdColorModel" enum="Boolean"
    expires_after="2021-02-01">
  <owner>dhoss@chromium.org</owner>
  <owner>thestig@chromium.org</owner>
  <summary>
    Records instances in which print preview encounters an unknown PPD color
    model.
  </summary>
</histogram>

<histogram name="Printing.CUPS.UsbSetupSource" enum="UsbPrinterSetupSource"
    expires_after="2021-07-15">
  <owner>baileyberro@chromium.org</owner>
  <owner>cros-peripherals@google.com</owner>
  <summary>
    Records the source from which a USB printer was configured in Chrome OS.
    Used to track relative usage of the various printer setup routes. Only emits
    after a successful printer setup.
  </summary>
</histogram>

<histogram name="Printing.CUPS.ValidPpdReference" enum="BooleanSuccess"
    expires_after="2020-08-01">
  <obsolete>
    Data no longer needed. Bug is resolved. 2020-12.
  </obsolete>
  <owner>skau@chromium.org</owner>
  <owner>luum@chromium.org</owner>
  <summary>
    Tracks printer setups with a valid/invalid PpdReference. PpdReferences are
    invalid if more than one field is specified. Due to a bug, some invalid
    references could be saved in users' profile, track if they need to be
    migrated. Recorded during printer install. Only tracked on ChromeOS.
  </summary>
</histogram>

<histogram name="Printing.CUPS.ZeroconfPrinterSetupResult"
    enum="PrinterSetupResult" expires_after="2021-08-28">
  <owner>kdlee@chromium.org</owner>
  <owner>cros-printing-dev@chromium.org</owner>
  <summary>
    The success or error code for the setup of a Zeroconf printer. Recorded when
    setup is attempted through the settings dialogs. Only recorded on Chrome OS.
    Printer setup results go into either this histogram or the
    Printing.CUPS.PrinterSetupResult histogram - not both.
  </summary>
</histogram>

<histogram name="Printing.PrinterCapabilities" units="ms" expires_after="M80">
  <owner>vkuzkokov@chromium.org</owner>
  <owner>skau@chromium.org</owner>
  <summary>
    Records the time it takes to pull capabilities of a single printer from
    OS-specific backend. Recorded immediately on completion.
  </summary>
</histogram>

<histogram name="Printing.PrintServers.ServersToQuery" units="servers"
    expires_after="2021-06-20">
  <owner>pawliczek@chromium.org</owner>
  <owner>skau@chromium.org</owner>
  <summary>
    Records the number of print servers that must be queried according to
    policies. Only non-zero values are recorded. The histogram is emitted when
    ExternalPrintServers* policies are loaded and processed. It happens when a
    profile is opened or when one of the policies is modified.
  </summary>
</histogram>

</histograms>

</histogram-configuration>
